package class7_2_TestsFixed;

/** Sorry... forgot to save yesterday's version... it was just getting started, anyhow */

public class CircularQueue<E> implements Queue<E> {
    private final int MAX_SIZE = 5; // Smaller value makes testing easier

    int indFront = 0; // The "front of the line" i.e. first items to come off
    int indRear = -1; // The "back of the line" i.e. most recently arrived items.

    E[] array = (E[]) new Object[MAX_SIZE];

    @Override
    public E poll() {
        if(isEmpty()) {
            return null;
        }

        E result = array[indFront];
        indFront++;
        if(indFront >= array.length) {
            indFront = 0;
        }
        // ERROR: Edge case. indFront needs to pass indRear for the list to be empty.
        // So +1 on indRear.
        if(indFront == (indRear + 1) % array.length) {
            // Queue is again empty!
            indFront = 0;
            indRear = -1;
        }

        return result;
    }

    @Override
    public boolean offer(E e) {
        // CHANGE: My own implementation.
        // TODO: Put your implementation here and see if tests work.
        if(isFull()) {
            return false;
        }

        indRear = (indRear+1)%array.length;
        array[indRear] = e;

        return true;
    }

    @Override
    public E peek() {
        if(isEmpty()) {
            return null;
        }

        return array[indFront];
    }

    @Override
    public boolean isEmpty() {
        return (indRear < 0);
    }

    /**
     * Returns true if no more elements can be added to the array.
     * @return true if full
     */
    private boolean isFull() {
        // ERROR: empty array could appear full.
        // So we explicitly check.
        return !isEmpty() && ((indRear+1)%array.length == indFront);
    }
}
