package class7_2_TestsBroken;

import class7_2_TestsFixed.Test;

import java.util.ArrayList;
import java.util.List;

/**
 * An ordered collection (list) of tests to be run.
 *
 * @see class7_2_TestsBroken.TestDriverArrayList for an example of usage.
 */
public class TestSet {
    private List<Test> tests = new ArrayList<Test>();

    /**
     * Run all tests
     */
    public void test() {
        for(Test t: tests) {
                t.run();
        }
    }

    /**
     * Add a test to the list
     * @param test The test to add.
     */
    public void addTest(Test test) {
        tests.add(test);
    }
}
